package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;
import com.stencyl.graphics.ScaleMode;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Config;
import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.motion.*;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class ActorEvents_0 extends ActorScript
{
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_Reset():Void
	{
		var __Self:Actor = actor;
		actor.setAnimation("0");
	}
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_MarkSelection():Void
	{
		var __Self:Actor = actor;
		/* Left out the first condition to demonstrate bugs. */
		if(((asNumber(__Self.getAnimation()) == 1) || (asNumber(__Self.getAnimation()) == 3)))
		{
			if((Engine.engine.getGameAttribute("PlayerA") : Bool))
			{
				__Self.setAnimation("2");
			}
			else
			{
				__Self.setAnimation("4");
			}
			Engine.engine.setGameAttribute("NumBlocks", ((Engine.engine.getGameAttribute("NumBlocks") : Float) + 1));
			Engine.engine.setGameAttribute("PlayerA", !((Engine.engine.getGameAttribute("PlayerA") : Bool)));
			playSound(getSound(50));
		}
	}
	
	
	public function new(dummy:Int, actor:Actor, dummy2:Engine)
	{
		super(actor);
		
	}
	
	override public function init()
	{
		
		/* =========================== On Actor =========================== */
		addMouseOverActorListener(actor, function(mouseState:Int, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled && 5 == mouseState)
			{
				_customBlock_MarkSelection();
			}
		});
		
		/* =========================== On Actor =========================== */
		addMouseOverActorListener(actor, function(mouseState:Int, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled && 1 == mouseState)
			{
				/* Make this check on Video006. */
				if(!((Engine.engine.getGameAttribute("GameOver") : Bool)))
				{
					if((asNumber(actor.getAnimation()) == 0))
					{
						if((Engine.engine.getGameAttribute("PlayerA") : Bool))
						{
							actor.setAnimation("1");
						}
						else
						{
							actor.setAnimation("3");
						}
						/* "Add this on Video007." */ playSound(getSound(49));
					}
				}
			}
		});
		
		/* =========================== On Actor =========================== */
		addMouseOverActorListener(actor, function(mouseState:Int, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled && -1 == mouseState)
			{
				if(((asNumber(actor.getAnimation()) == 1) || (asNumber(actor.getAnimation()) == 3)))
				{
					actor.setAnimation("0");
				}
			}
		});
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}