package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;
import com.stencyl.graphics.ScaleMode;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Config;
import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.motion.*;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;
import box2D.collision.shapes.B2Shape;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class SceneEvents_0 extends SceneScript
{
	public var _StartPosX:Float;
	public var _StartPosY:Float;
	public var _Block11:Actor;
	public var _Block12:Actor;
	public var _Block13:Actor;
	public var _Block21:Actor;
	public var _Block22:Actor;
	public var _Block23:Actor;
	public var _Block31:Actor;
	public var _Block32:Actor;
	public var _Block33:Actor;
	public var _CurRes:Float;
	public var _CurPlayer:Actor;
	public var _uiResWins:Actor;
	public var _uiResTie:Actor;
	public var _uiScore1:Float;
	public var _uiScore2:Float;
	public var _uiRounds:Float;
	public var _CanSetScore:Bool;
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_CreateBlock(__ref:Dynamic, __x:Float, __y:Float):Actor
	{
		if((__ref == null))
		{
			createRecycledActor(getActorType(0), __x, __y, Script.FRONT);
			return getLastCreatedActor();
		}
		else
		{
			(__ref : Actor).say("ActorEvents_0", "_customBlock_Reset");
		}
		return __ref;
	}
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_CheckWinner():Float
	{
		if((_customBlock_IsInRow(_Block11, _Block12, _Block13) : Bool))
		{
			return asNumber(_Block11.getAnimation());
		}
		else if((_customBlock_IsInRow(_Block21, _Block22, _Block23) : Bool))
		{
			return asNumber(_Block21.getAnimation());
		}
		else if((_customBlock_IsInRow(_Block31, _Block32, _Block33) : Bool))
		{
			return asNumber(_Block31.getAnimation());
		}
		else if((_customBlock_IsInRow(_Block11, _Block21, _Block31) : Bool))
		{
			return asNumber(_Block11.getAnimation());
		}
		else if((_customBlock_IsInRow(_Block12, _Block22, _Block32) : Bool))
		{
			return asNumber(_Block12.getAnimation());
		}
		else if((_customBlock_IsInRow(_Block13, _Block23, _Block33) : Bool))
		{
			return asNumber(_Block13.getAnimation());
		}
		else if((_customBlock_IsInRow(_Block11, _Block22, _Block33) : Bool))
		{
			return asNumber(_Block11.getAnimation());
		}
		else if((_customBlock_IsInRow(_Block13, _Block22, _Block31) : Bool))
		{
			return asNumber(_Block13.getAnimation());
		}
		else
		{
			if(((Engine.engine.getGameAttribute("NumBlocks") : Float) >= 9))
			{
				return 0;
			}
		}
		return -1;
	}
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_IsInRow(__a:Actor, __b:Actor, __c:Actor):Bool
	{
		if(!(asNumber(__a.getAnimation()) == 0))
		{
			if(((asNumber(__a.getAnimation()) == asNumber(__b.getAnimation())) && (asNumber(__b.getAnimation()) == asNumber(__c.getAnimation()))))
			{
				return true;
			}
		}
		return false;
	}
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_NewPos(__s:Float, __v:Float, __m:Float):Float
	{
		return ((__s + ((Engine.engine.getGameAttribute("BlockMargin") : Float) / 2)) + ((__v + (Engine.engine.getGameAttribute("BlockMargin") : Float)) * __m));
	}
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_ResetBoard(__sx:Float, __sy:Float):Void
	{
		/* "Bug: Implement this on Video008." */ stopAllSounds();
		_Block11 = (_customBlock_CreateBlock(_Block11, (_customBlock_NewPos(__sx, (Engine.engine.getGameAttribute("BlockWidth") : Float), 0) : Float), (_customBlock_NewPos(__sy, (Engine.engine.getGameAttribute("BlockHeight") : Float), 0) : Float)) : Actor);
		_Block12 = (_customBlock_CreateBlock(_Block12, (_customBlock_NewPos(__sx, (Engine.engine.getGameAttribute("BlockWidth") : Float), 1) : Float), (_customBlock_NewPos(__sy, (Engine.engine.getGameAttribute("BlockHeight") : Float), 0) : Float)) : Actor);
		_Block13 = (_customBlock_CreateBlock(_Block13, (_customBlock_NewPos(__sx, (Engine.engine.getGameAttribute("BlockWidth") : Float), 2) : Float), (_customBlock_NewPos(__sy, (Engine.engine.getGameAttribute("BlockHeight") : Float), 0) : Float)) : Actor);
		_Block21 = (_customBlock_CreateBlock(_Block21, (_customBlock_NewPos(__sx, (Engine.engine.getGameAttribute("BlockWidth") : Float), 0) : Float), (_customBlock_NewPos(__sy, (Engine.engine.getGameAttribute("BlockHeight") : Float), 1) : Float)) : Actor);
		_Block22 = (_customBlock_CreateBlock(_Block22, (_customBlock_NewPos(__sx, (Engine.engine.getGameAttribute("BlockWidth") : Float), 1) : Float), (_customBlock_NewPos(__sy, (Engine.engine.getGameAttribute("BlockHeight") : Float), 1) : Float)) : Actor);
		_Block23 = (_customBlock_CreateBlock(_Block23, (_customBlock_NewPos(__sx, (Engine.engine.getGameAttribute("BlockWidth") : Float), 2) : Float), (_customBlock_NewPos(__sy, (Engine.engine.getGameAttribute("BlockHeight") : Float), 1) : Float)) : Actor);
		_Block31 = (_customBlock_CreateBlock(_Block31, (_customBlock_NewPos(__sx, (Engine.engine.getGameAttribute("BlockWidth") : Float), 0) : Float), (_customBlock_NewPos(__sy, (Engine.engine.getGameAttribute("BlockHeight") : Float), 2) : Float)) : Actor);
		_Block32 = (_customBlock_CreateBlock(_Block32, (_customBlock_NewPos(__sx, (Engine.engine.getGameAttribute("BlockWidth") : Float), 1) : Float), (_customBlock_NewPos(__sy, (Engine.engine.getGameAttribute("BlockHeight") : Float), 2) : Float)) : Actor);
		_Block33 = (_customBlock_CreateBlock(_Block33, (_customBlock_NewPos(__sx, (Engine.engine.getGameAttribute("BlockWidth") : Float), 2) : Float), (_customBlock_NewPos(__sy, (Engine.engine.getGameAttribute("BlockHeight") : Float), 2) : Float)) : Actor);
		Engine.engine.setGameAttribute("GameOver", false);
		Engine.engine.setGameAttribute("NumBlocks", 0);
		_CanSetScore = true;
		loopSound(getSound(53));
	}
	
	
	public function new(dummy:Int, dummy2:Engine)
	{
		super();
		nameMap.set("StartPosX", "_StartPosX");
		_StartPosX = 0.0;
		nameMap.set("StartPosY", "_StartPosY");
		_StartPosY = 0.0;
		nameMap.set("Block11", "_Block11");
		nameMap.set("Block12", "_Block12");
		nameMap.set("Block13", "_Block13");
		nameMap.set("Block21", "_Block21");
		nameMap.set("Block22", "_Block22");
		nameMap.set("Block23", "_Block23");
		nameMap.set("Block31", "_Block31");
		nameMap.set("Block32", "_Block32");
		nameMap.set("Block33", "_Block33");
		nameMap.set("CurRes", "_CurRes");
		_CurRes = 0.0;
		nameMap.set("CurPlayer", "_CurPlayer");
		nameMap.set("uiResWins", "_uiResWins");
		nameMap.set("uiResTie", "_uiResTie");
		nameMap.set("uiScore1", "_uiScore1");
		_uiScore1 = 0.0;
		nameMap.set("uiScore2", "_uiScore2");
		_uiScore2 = 0.0;
		nameMap.set("uiRounds", "_uiRounds");
		_uiRounds = 0.0;
		nameMap.set("CanSetScore", "_CanSetScore");
		_CanSetScore = false;
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		_StartPosX = ((scripts.Design_2_2_SceneFunctions._customBlock_HalfScreenWidth() : Float) - ((Engine.engine.getGameAttribute("BoardSize") : Float) / 2));
		_StartPosY = ((scripts.Design_2_2_SceneFunctions._customBlock_HalfSceneHeight() : Float) - ((Engine.engine.getGameAttribute("BoardSize") : Float) / 2));
		_customBlock_ResetBoard(_StartPosX, _StartPosY);
		createRecycledActor(getActorType(0), 288, 410, Script.FRONT);
		_CurPlayer = getLastCreatedActor();
		/* "Modular the following later." */ createRecycledActor(getActorType(46), ((scripts.Design_2_2_SceneFunctions._customBlock_HalfScreenWidth() : Float) - 179), ((scripts.Design_2_2_SceneFunctions._customBlock_HalfSceneHeight() : Float) - 37), Script.FRONT);
		_uiResTie = getLastCreatedActor();
		getLastCreatedActor().disableActorDrawing();
		createRecycledActor(getActorType(44), ((scripts.Design_2_2_SceneFunctions._customBlock_HalfScreenWidth() : Float) - 158), ((scripts.Design_2_2_SceneFunctions._customBlock_HalfSceneHeight() : Float) - 79), Script.FRONT);
		_uiResWins = getLastCreatedActor();
		getLastCreatedActor().disableActorDrawing();
		_uiScore1 = 0;
		_uiScore2 = 0;
		_uiRounds = 1;
		
		/* ======================== When Updating ========================= */
		addWhenUpdatedListener(null, function(elapsedTime:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				/* "Display player's turn." */ if((Engine.engine.getGameAttribute("PlayerA") : Bool))
				{
					_CurPlayer.setAnimation("2");
				}
				else
				{
					_CurPlayer.setAnimation("4");
				}
				/* "Check winner condition." */ _CurRes = (_customBlock_CheckWinner() : Float);
				if((_CurRes == 0))
				{
					_uiResTie.enableActorDrawing();
					_uiResWins.disableActorDrawing();
					if(_CanSetScore)
					{
						stopAllSounds();
						playSound(getSound(52));
						_CanSetScore = false;
					}
				}
				else if((_CurRes == 2))
				{
					_uiResWins.enableActorDrawing();
					_uiResWins.setAnimation("1");
					_uiResTie.disableActorDrawing();
					if(_CanSetScore)
					{
						stopAllSounds();
						playSound(getSound(51));
						_uiScore1 += 1;
						_CanSetScore = false;
					}
				}
				else if((_CurRes == 4))
				{
					_uiResWins.enableActorDrawing();
					_uiResWins.setAnimation("2");
					_uiResTie.disableActorDrawing();
					if(_CanSetScore)
					{
						stopAllSounds();
						playSound(getSound(51));
						_uiScore2 += 1;
						_CanSetScore = false;
					}
				}
				else
				{
					_uiResWins.disableActorDrawing();
					_uiResTie.disableActorDrawing();
				}
				if((_CurRes >= 0))
				{
					Engine.engine.setGameAttribute("GameOver", true);
				}
				/* Show "new round" button when game is over. Otherwise hide this button. */
				if((Engine.engine.getGameAttribute("GameOver") : Bool))
				{
					getActor(6).say("abMouseHover", "_customBlock_SetHidden", [false]);
					_CurPlayer.disableActorDrawing();
				}
				else
				{
					getActor(6).say("abMouseHover", "_customBlock_SetHidden", [true]);
					_CurPlayer.enableActorDrawing();
				}
			}
		});
		
		/* ========================= When Drawing ========================= */
		addWhenDrawingListener(null, function(g:G, x:Float, y:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				g.setFont(getFont(27));
				if(!((Engine.engine.getGameAttribute("GameOver") : Bool)))
				{
					g.drawString("" + "Player's Turn:", 265, 385);
				}
				g.drawString("" + (("Round(s): ") + ("" + _uiRounds)), 16, (getScreenHeight() - 30));
				g.setFont(getFont(48));
				g.drawString("" + _uiScore1, (100 - (getFont(48).getTextWidth("" + _uiScore1)/Engine.SCALE / 2)), 160);
				g.drawString("" + _uiScore2, (548 - (getFont(48).getTextWidth("" + _uiScore2)/Engine.SCALE / 2)), 160);
			}
		});
		
		/* =========================== On Actor =========================== */
		addMouseOverActorListener(getActor(6), function(mouseState:Int, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled && 5 == mouseState)
			{
				/* "Introduce bug by not checking for hidden attribute." */ if(!((getActor(6).getValue("abMouseHover", "_Hidden") : Bool)))
				{
					_customBlock_ResetBoard(_StartPosX, _StartPosY);
					_uiRounds += 1;
				}
			}
		});
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}