package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;
import com.stencyl.graphics.ScaleMode;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Config;
import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.motion.*;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;
import box2D.collision.shapes.B2Shape;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class SceneEvents_2 extends SceneScript
{
	public var _MadeBy:String;
	public var _Author:String;
	public var _Date:String;
	public var _Version:String;
	
	
	public function new(dummy:Int, dummy2:Engine)
	{
		super();
		nameMap.set("MadeBy", "_MadeBy");
		_MadeBy = "Made by";
		nameMap.set("Author", "_Author");
		_Author = "n3rd0x";
		nameMap.set("Date", "_Date");
		_Date = "01/09-2020";
		nameMap.set("Version", "_Version");
		_Version = "v.1.0.0";
		
	}
	
	override public function init()
	{
		
		/* ========================= When Drawing ========================= */
		addWhenDrawingListener(null, function(g:G, x:Float, y:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				g.setFont(getFont(48));
				g.drawString("" + _MadeBy, ((scripts.Design_2_2_SceneFunctions._customBlock_HalfScreenWidth() : Float) - (scripts.Design_2_2_SceneFunctions._customBlock_HalfTextWidth(_MadeBy, getFont(48)) : Float)), ((scripts.Design_2_2_SceneFunctions._customBlock_HalfSceneHeight() : Float) + 0));
				g.setFont(getFont(27));
				g.drawString("" + _Author, ((scripts.Design_2_2_SceneFunctions._customBlock_HalfScreenWidth() : Float) - (scripts.Design_2_2_SceneFunctions._customBlock_HalfTextWidth(_Author, getFont(27)) : Float)), ((scripts.Design_2_2_SceneFunctions._customBlock_HalfSceneHeight() : Float) + 50));
				g.drawString("" + _Date, ((scripts.Design_2_2_SceneFunctions._customBlock_HalfScreenWidth() : Float) - (scripts.Design_2_2_SceneFunctions._customBlock_HalfTextWidth(_Date, getFont(27)) : Float)), ((scripts.Design_2_2_SceneFunctions._customBlock_HalfSceneHeight() : Float) + 80));
				g.drawString("" + _Version, ((scripts.Design_2_2_SceneFunctions._customBlock_HalfScreenWidth() : Float) - (scripts.Design_2_2_SceneFunctions._customBlock_HalfTextWidth(_Version, getFont(27)) : Float)), ((scripts.Design_2_2_SceneFunctions._customBlock_HalfSceneHeight() : Float) + 100));
			}
		});
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}